/****************************************************************************
*
*	AVR Fish, last major edit: Dec 6th, 2007
*
*   default clock setting: Int. RC Osc.; Start-up time: 6CK + 65ms
****************************************************************************/

//SoR Include
#include "SoR_Utils.h" //includes all the technical stuff
#include "kinematics.h" //the array of kinematics
#include "control.c" //the array of kinematics
#include "axon_test.c" //include this is doing a function test for the Axon


int main(void)
	{
	//declare variables here
	int i=0;//useless variable


	/****************INITIALIZATIONS*******************/
	//other stuff Im experimenting with for SoR
	uartInit();  // initialize the UART (serial port)
    uartSetBaudRate(0, 38400); // set UARTE speed, for EasyRadio
    uartSetBaudRate(1, 115200); // set UARTD speed, for USB connection
    uartSetBaudRate(2, 115200); // set UARTH speed
    uartSetBaudRate(3, 115200); // set UARTJ speed
	//G=Ground, T=Tx (connect to external Rx), R=Rx (connect to external Tx)

	rprintfInit(uart1SendByte);// initialize rprintf system and configure uart1 (USB) for rprintf

	timer0Init(); // initialize the timer system
	
	configure_ports(); // configure which ports are analog, digital, etc.
	a2dInit(); // initialize analog to digital converter (ADC)
	a2dSetPrescaler(ADC_PRESCALE_DIV32); // configure ADC scaling
	a2dSetReference(ADC_REFERENCE_AVCC); // configure ADC reference voltage

	LED_on();

	rprintf("\r\nSystem Warming Up");

	/*
	//change Easy Radio baud to 38400
	//ALL devices must be configured to 19200 for this command to work wirelessly
	uartSetBaudRate(0, 19200);//19200 is default
	delay_cycles(65500);
	rprintf("ER_CMD#U5");//ER_CMD#U4 for 19200, ER_CMD#U5 for 38400 maximum
	delay_cycles(6550);
	rprintf("ACK");
	delay_cycles(65500);
	uartSetBaudRate(0, 38400);
	delay_cycles(5000);
	*/

	//let system stabelize for X time
	for(i=0;i<=16;i++) // 32750*1.003/234*8 = 2.2 seconds
		{
		delay_cycles(32000);//~280 milliseconds
		rprintf(".");
		}

	delay_cycles(6000);
	LED_off();

	/**************************************************/

	
	/*********ADD YOUR CODE BELOW THIS LINE **********/

//***add a flush ADC loop here
//read each ADC once to get it all working properly

	//calibrate sensors; start robot off in zero neutral state
		//store accelerometer data
		accel_X_calib=a2dConvert8bit(accelerometer_X);
		accel_Y_calib=a2dConvert8bit(accelerometer_Y);
		accel_Z_calib=a2dConvert8bit(accelerometer_Z);
		
		//store navigational data: depth, compass, gyro
		depth_calib=a2dConvert8bit(depth_sensor);
		//compass_calib=a2dConvert8bit(compass);
		gyro_X_calib=a2dConvert8bit(gyro_X);
		gyro_Y_calib=a2dConvert8bit(gyro_Y);
		//gyro_Z_calib=a2dConvert8bit(gyro_Z);


	rprintf("Initialization Complete \r\n");
	
	reset_timer();

	while(1)
		{

		control();//use this for fish control

		//test();//tests all of the Axon's functions



/*
		sbi(PORTD, PD7);//port high
		delay_cycles(348);
		cbi(PORTD, PD7);//port low
*/
		delay_cycles(1000);//a small delay to prevent crazy oscillations
		}
	/*********ADD YOUR CODE ABOVE THIS LINE **********/

	return 0;
	}


/*********************COMMAND LIST*************************

delay_cycles(cycles);
Delays - you can make your robot wait for a certain amount of time with this function.
Put the number of computational cycles to delay in the ().
see note in SoR_Utils.h

button_pressed()
returns a 1 if button is pressed, a zero otherwise

***********************************************************/
