/****************************************************************************
*
*	ERP, last major edit: Feb 24th, 2008
*
****************************************************************************/

//SoR Include
#include "SoR_Utils.h" //includes all the technical stuff
#include "hardware.c" //declare hardware variables and ports
#include "sensors.c" //sensor libraries for sonar, sharp IR, etc.
#include "Blackfin_Axon.c" //files for Blackfin Robot camera
#include "ERP_motions.h" //the array of kinematics
#include "gaits.c" //code for gait motion control
#include "control.c" //your code goes in here
#include "axon_test.c" //include this is doing a function test for the Axon
#include "fetch.c" //play fetch software
#include "IR_scan_mapping.c" //have ERP scan sharp IR head for 3D map

int main(void)
	{
	//declare variables here
	int i=0;//useless variable
	int j=0;

	unsigned long int random_number;

	/****************INITIALIZATIONS*******************/
	//other stuff Im experimenting with for SoR
	uartInit();  // initialize the UART (serial port)
    uartSetBaudRate(0, 115200); // set UARTE speed, for Bluetooth
    uartSetBaudRate(1, 115200); // set UARTD speed, for USB connection, up to 500k, try 115200 if it doesn't work
    uartSetBaudRate(2, 38400); // set UARTH speed
    uartSetBaudRate(3, 38400); // set UARTJ speed, for Blackfin
	//G=Ground, T=Tx (connect to external Rx), R=Rx (connect to external Tx)

	rprintfInit(uart0SendByte);// initialize rprintf system and configure uart0 (bluetooth) for rprintf

	configure_ports(); // configure which ports are analog, digital, etc.

	LED_on();

	rprintf("\r\nSystem Warming Up");

	// initialize the timer system (comment out ones you don't want)
 	init_timer0(TIMER_CLK_1024);
 	init_timer1(TIMER_CLK_64);
 	init_timer2(TIMER2_CLK_64);
 	init_timer3(TIMER_CLK_64);
 	init_timer4(TIMER_CLK_64);
	//timer5Init();

	a2dInit(); // initialize analog to digital converter (ADC)
	a2dSetPrescaler(ADC_PRESCALE_DIV32); // configure ADC scaling
	a2dSetReference(ADC_REFERENCE_AVCC); // configure ADC reference voltage

	//let system stabelize for X time
	for(i=0;i<16;i++)
		{
		j=a2dConvert8bit(i);//read each ADC once to get it working accurately
		delay_cycles(5000); //keep LED on long enough to see Axon reseting
		rprintf(".");
		}

	LED_off();

	rprintf("Initialization Complete \r\n");

	//reset all timers to zero
	reset_timer0();
	reset_timer1();
	reset_timer2();
	reset_timer3();
	reset_timer4();
	//reset_timer5();

	/**************************************************/

	
	/*********ADD YOUR CODE BELOW THIS LINE **********/

	//go track a ball and grab it
	/*set_up_cam();
	while(1)
		{
		//play_fetch();
		//grab_ball();
		//throw_ball();
		track_ball();
		//Blackfin_center_pixel();
		//Blackfin_YUV_Mean();

		//scanned_value=sharp_IR_interpret_GP2Y0A21YK(a2dConvert8bit(14));
		//delay_ms(25);
		}*/

	//dance code, for kinematics contest
	/*while(1)
		{
		LED_all_off();

		//read random values on ADC port, sum total
		for(i=0;i<16;i++)
			random_number=a2dConvert10bit(i);
		//sets random seed to current ADC value
		srandom(random_number);
		//returns random number between 0 and 32767</font>
		random_number = rand()%10;//look at least significant digit only (divide by 10, take remainder)
		rprintf("\r\nrandom number = %d\r\n",random_number);

		//based on random number, do some random dancing
		if(random_number==0)
			walk_forward(20);
		if(random_number==1)
			walk_forward(90);
		if(random_number==2)
			dance_lift(40);
		if(random_number==3)
			dance_lift(100);
		if(random_number==4)
			dance_cheering(80);
		if(random_number==5)
			chicken_dance();
		if(random_number==6)
			dance_cheering(50);
		if(random_number==7)
			claw_attack();
		if(random_number==8)
			dance_bowing(30);
		if(random_number==9)
			dance_bowing(100);

		delay_ms(100);
		}*/

	//this code runs the 3D scan stuff . . . robot scans, then avoids walls and cliffs
	/*Blackfin_Initialize();
	while(1)
		{
		int turn_decision;

		//look for object, move towards it
		//add this code to use camera and track object after avoiding cliff
		for (i=0;i<10;i++)
			move_head_into_position(60,-180);//head look down, straight//works as 60,-170

		Blackfin_Bin_Range(0, 65, 240, 100, 140, 160, 230);//for tracking red sparkfun box
		Blackfin_Blob_Detect(0);
		delay_ms(5);

		//if object is detected an in grabbing range
		if (pixels > 6 && X_centroid < 55 && X_centroid > 25 && Y_centroid > 18 && Y_centroid < 46)
			{
			grab_ball();
			throw_ball();
			for (i=0;i<15;i++)
				{
				fold_for_mobot();
				delay_ms(20);
				}
			}

		//scan environment with Sharp IR
		do_3D_scan();
		//now look at data and decide what is what and where to go, lower numbers make it turn away more often
		turn_decision = avoid_objects_cliffs(7);

		//given environment, move the robot appropriately
		if (turn_decision == 11)//if no clear path, turn around
			{
			for (i=0;i<255;i++)
				robot_turn_right();
				delay_ms(20);
			}
		else if (turn_decision < 4)
			{
			for (i=0;i<10;i++)
				robot_turn_left();
				delay_ms(20);
			}
		else if (turn_decision > 6)
			{
			for (i=0;i<50;i++)//left and right are different values because of unequal system friction
				robot_turn_right();
				delay_ms(20);
			}
		else
			{
			for (i=0;i<70;i++)
				robot_go_straight();
				delay_ms(20);
			}
		}*/


	//DE current sensor:
	//20 red+green flash, 40 red, 7 green, 
	

	//remote controlled ERP code
	char cByte;
	long int headh=730;
	long int headv=990;
	while(1)
		{
		cByte=uart0GetByte(); //get byte from UART0 on the axon
		if(cByte!=-1)//no new data
			{
			//motion
			if (cByte == 'w')
				{
				wheel_left(400);
				wheel_right(1100);
				}
			if (cByte == 's')
				{
				wheel_left(1100);
				wheel_right(400);
				}
			if (cByte == 'd')
				{
				wheel_left(400);
				wheel_right(400);
				}
			if (cByte == 'a')
				{
				wheel_left(1100);
				wheel_right(1100);
				}

			//hard motions
			if (cByte == 'z')
				{
				chicken_dance();
				}
			if (cByte == 'x')
				{
				//line_backer();
				}
			if (cByte == 'c')
				{
				claw_attack();
				}
			if (cByte == 'b')
				{
				fold_for_mobot();
				fold_for_mobot();
				fold_for_mobot();
				}

			//special gaits
			if (cByte == '1')
				{
				walk_forward(20);
				}
			if (cByte == '2')
				{
				dance_lift(100);
				}
			if (cByte == '3')
				{
				dance_cheering(50);
				}
			if (cByte == '4')
				{
				dance_bowing(100);
				}


			if (cByte == '6')
				{
				throw_ball_step1();
				}
			if (cByte == '7')
				{
				throw_ball_step2();
				}

			//head control
			if (cByte == 'j')
				{
				headh=headh-20;
				camera_hor(headh);
				}
			if (cByte == 'l')
				{
				headh=headh+20;
				camera_hor(headh);
				}
			if (cByte == 'i')
				{
				headv=headv+20;
				camera_ver(headv);
				}
			if (cByte == 'k')
				{
				headv=headv-20;
				camera_ver(headv);
				}

			//wheel_left();
			//wheel_right
			delay_ms(19);
			}
		}


//cheer();
//chicken_dance();
	fold_for_mobot();
	fold_for_mobot();
	fold_for_mobot();
	
	Blackfin_Initialize();////////////////////////////////
	
	//find mean color values of environment
	Blackfin_YUV_Mean();////////////////////////////////
	

	while(1)
		{
//Blackfin_YUV_Mean();////////////////////////////////
	//control();//use this for your code

//cheer();
//chicken_dance();
	//fold_for_mobot();

		//check out RBG values for fun
		//Blackfin_YUV_2_RGB_accurate();

		//tweak brightness mean
		/*Y_mean=Y_mean+60;
		if (Y_mean > 255)
			Y_mean=255;*/


		//track blue LED, hardcoded
		//				 bin ymin ymax umin umax vmin vmax
		//Blackfin_Bin_Range(0, 60, 255, 160, 255, 0, 120);//Y=Luminence, U=Chroma Blue, V=Chroma Red; Y_mean+10


		//track blue LED auto-calibrate
		//Blackfin_Bin_Range(0, (Y_mean+20), 255, (U_mean+50), 255, 0, (V_mean-20));

		//track flame auto-calibrate
		//Blackfin_Bin_Range(0, (Y_mean+15), 255, 0, 120, (V_mean+15), 255);//works ok-ish
		//Blackfin_Bin_Range(0, (Y_mean), 255, 0, 200, (V_mean+20), 255);

		//pikachu
		//Blackfin_Bin_Range(0, 150, 255, 0, 90, 130, 255);//works ok-ish
		

		//MOBOT track white line -> ignore red, and U allowed
		//Blackfin_Bin_Range(0, (Y_mean+90), 255, (U_mean+5), 255, (V_mean+5), 255);//older
		//Blackfin_Bin_Range(0, (Y_mean+50), 255, 0, 255, 0, (V_mean));

		
		//Blackfin_Bin_Range(0, (Y_mean+80), 255, 0, 255, 0, 255);//works for MOBOT
		
		
		//WORKS DONT TOUCH - USED SPEED 70, HEADTRACK 1,16
		//Blackfin_Bin_Range(0, (Y_mean+80), 255, 0, 255, 0, 255);//works
		


		//find blobs for bin#
		Blackfin_Blob_Detect(0);////////////////////////////////
		//delay_ms(500);
		//pixel count, damping ratio
		Blackfin_HeadTrack(1, 25);////////////////////////////////

		//ERP_body_track();

/*
		sbi(PORTD, PD7);//port high
		delay_cycles(348);
		cbi(PORTD, PD7);//port low
*/
		delay_cycles(1000);//a small delay to prevent crazy oscillations
		}
	/*********ADD YOUR CODE ABOVE THIS LINE **********/

	return 0;
	}
