//This program has the ERP head do a scan with a sharp IR
//it 


int x;
int y;
int counter;
int scanned_value;
int distance_map[11][3]={{0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0},
						 {0,0,0}};//initialize 3D map
long signed int head_x_scan;
long signed int head_y_scan;

/*
pseudocode:

scan real close and low
if sees something, return decision

if doesn't see something, raise scanner up a bit
repeat

if never sees anything, do whatever
*/

//moves head to certain position (actual servo commands)
void move_head_into_position(int a, int b)
	{
	//wait until servo is in new position (do several times)
	for(counter=0;counter<6;counter++)//higher the counter, faster the head scans
		{
		//go to new position, home_camera positions are predefined as camera looking straight
		camera_hor(home_camera_hor+a);//increase to look right
		camera_ver(home_camera_ver+b);//decrease to look down

		delay_ms(20);//typical delay needed or servos break (a bad thing)
		}
	}

//display range with numerical display
void output_range(void)
	{
			//debugging output for Axon II
			//if you don't have Axon II, comment this out! silly . . .
			if (scanned_value>45)
				LED_nine();
			else if (scanned_value>40)
				LED_eight();
			else if (scanned_value>35)
				LED_seven();
			else if (scanned_value>30)
				LED_six();
			else if (scanned_value>25)
				LED_five();
			else if (scanned_value>20)
				LED_four();
			else if (scanned_value>15)
				LED_three();
			else if (scanned_value>10)
				LED_two();
			else if (scanned_value>5)
				LED_one();
			else if (scanned_value>=0)
				LED_zero();
	}


//look at map and make a decision on what is/isn't an object/cliff, return a value 0->10, far left to far right
//threshold_range is likelihood of calling something bad; this is linear, although sharp IR is non-linear (I'm lazy!)
int avoid_objects_cliffs(int threshold_range)
	{
	int x;
	long signed int sum;
	int minimum_direction=11;//set to 11, if minimum not found, potentially means it is stuck in a corner (local minima)
	long int minimum_distance=65500;//find the lowest number for clearest path

	//set thresholds (must test to get these values), basically +/- a few from the level ground reading
	//53 y=0, 36 y=1, 22 y=2
	int cliff_threshold_y0=53-threshold_range;
	int object_threshold_y0=53+threshold_range;
	int cliff_threshold_y1=35-threshold_range;
	int object_threshold_y1=35+threshold_range+5;
	int object_threshold_y2=0+threshold_range+15;

	
	//search through matrix marking stuff as 255 if an object or cliff is detected
	for (x=0;x<10;x++)
		{
		// (high numbers for objects, low numbers for cliffs)
		//y=0, really close objects
		//if an object or cliff detected
		if (distance_map[x][0] > object_threshold_y0 || distance_map[x][0] < cliff_threshold_y0)
			distance_map[x][0]=255;
		//add buffer zone near detected objects
		if (distance_map[x+1][0] > object_threshold_y0 || distance_map[x+1][0] < cliff_threshold_y0)
			distance_map[x][0]=255;

		//y=1, medium distance objects
		//if an object or cliff detected
		if (distance_map[x][1] > object_threshold_y1 || distance_map[x][1] < cliff_threshold_y1)
			distance_map[x][1]=255;
		//add buffer zone near detected objects
		if (distance_map[x+1][1] > object_threshold_y1 || distance_map[x+1][1] < cliff_threshold_y1)
			distance_map[x][1]=255;

		//y=2, for distant objects
		//uncomment this section if you want the robot to avoid distant objects
		//if an object (looking straight, no cliff, duh!)
		if (distance_map[x][2] > object_threshold_y2)
			distance_map[x][2]=255;
		//add buffer zone near detected objects
		if (distance_map[x+1][2] > object_threshold_y2)
			distance_map[x][2]=255;
		}

	//print out the processed map
	rprintf("\r\nprocessed map:\r\n");
	for (y=0;y<3;y++)
		{
		for (x=0;x<10;x++)
			rprintf("%d	",distance_map[x][y]);
		rprintf("\r\n");//go to next line
		}

	//find the shortest straight path (sum of path is lowest number)
	for (x=0;x<10;x++)
		{
		//find value of distance
		if (distance_map[x][0] != 255) // if an immediate turn isn't required, it can move a bit closer
			sum=abs(distance_map[x][0]+distance_map[x][1]+distance_map[x][2] -53 -35);
		else
			sum=65500;

		//if distance is shorter than minimum
		if (sum < minimum_distance)
			{
			//store new distance and direction vector (because it is better)
			minimum_distance=sum;
			minimum_direction=x;
			rprintf("\r\n min distance:%d%d direction:%d ",minimum_distance, minimum_direction);
			}
		}

	if (minimum_direction==0)
		LED_zero();
	else if (minimum_direction==1)
		LED_one();
	else if (minimum_direction==2)
		LED_two();
	else if (minimum_direction==3)
		LED_three();
	else if (minimum_direction==4)
		LED_four();
	else if (minimum_direction==5)
		LED_five();
	else if (minimum_direction==6)
		LED_six();
	else if (minimum_direction==7)
		LED_seven();
	else if (minimum_direction==8)
		LED_eight();
	else if (minimum_direction==9)
		LED_nine();
	else if (minimum_direction==11)
		LED_all_off();

	return minimum_direction;
	}

//do a scan with the sharp IR and record ranges
void do_3D_scan(void)
	{
	//declare starting scan position
	head_x_scan=-200;//change value below, too (represents far left starting point)
	head_y_scan=-200;

	//move to starting position
	move_head_into_position(head_x_scan,head_y_scan);

	rprintf("\r\n\r\n mapping \r\n");
	rprintf("original map:\r\n");
	for(y=0;y<3;y++)
		{
		//reset x position
		head_x_scan=-200;
		move_head_into_position(head_x_scan,head_y_scan);
		move_head_into_position(head_x_scan,head_y_scan);

		for(x=0;x<10;x++)
			{
			//declare new x position
			head_x_scan=head_x_scan+30;// (130*2)/10=30
			
			//move into new location
			move_head_into_position(head_x_scan,head_y_scan);

			//Sharp GP2Y0A21YK IR Range Sensor - 4 cm to 30 cm
			scanned_value=a2dConvert8bit(14);
			distance_map[x][y]=scanned_value;
			rprintf("%d	",scanned_value);//print out a map

			//output_range();
			}
		rprintf("\r\n");

		//go to new y position
		head_y_scan=head_y_scan+75;// 200/3=66
		}
	}


/*pseudocode
set cliff thresholds for each level
set object thresholds for each level

level 1
  for x++
    if x,y=cliff or object, or x+1,y=cliff or object
	  x,y=255

do same for level 2 and 3, but different thresholds

now find longest clear path
for x++
   for y++
     x,y=sum
	 if sum is minimum, save
return angle of minimum

*/
