//play fetch algorithms

int sharp_IR;

//algorithm for hand to grab something centered in front of it
void grab_ball(void)
	{
	int k;

	rprintfInit(uart1SendByte);
	rprintf("Grabbing Ball\r\n");

	//prepare arm above to grab ball
	for(k=0;k<40;k++)
		{
		//move arm into centered vertical position
		arm_right_base(620);
		arm_right_J1(750);
		arm_right_J2(350);
		
		//open gripper
		arm_right_claw(1100);

		delay_ms(20);
		}

	//move hand onto ball
	for(k=0;k<40;k++)
		{
		//move arm down
		arm_right_base(620);
		arm_right_J1(1080);
		arm_right_J2(310);
		
		//open gripper
		arm_right_claw(1100);

		delay_ms(20);
		}
	delay_ms(200);

	//move forward to get ball into hand
	for(k=0;k<40;k++)
		{
		//drive into ball as it . . .
		wheel_left(699);
		wheel_right(733);

		delay_ms(20);
		}

	//grab ball
	for(k=0;k<40;k++)
		{
		//close gripper
		arm_right_claw(400);

		delay_ms(20);
		}

	//move reverse to get back into old position
	for(k=0;k<8;k++)
		{
		robot_go_reverse();
		//close gripper
		arm_right_claw(400);

		delay_ms(20);
		}
	
	//fold arm back to store ball
	for(k=0;k<40;k++)
		{
		//bring arm into fold position, mobot fold?
		fold_for_mobot();

		delay_ms(20);
		}
	}

	
void throw_ball(void)
	{
	int k;

	rprintfInit(uart1SendByte);
	rprintf("Throwing Ball\r\n");

	//grab ball
	for(k=0;k<40;k++)
		{
		arm_right_base(620);
		arm_right_J1(850);
		arm_right_J2(500);//700 is straight with J1
		arm_right_claw(1000);//open close
		delay_ms(20);
		}
	}

//find the ball, and move to it
void track_ball(void)
	{
	rprintf("\r\n looking for object");
	//track flame, but maybe change to track orange ball?
	//Blackfin_Bin_Range(0, (Y_mean+15), 255, 0, 120, (V_mean+15), 255);
	//Blackfin_Bin_Range(0, 1, 240, 0, 90, 190, 255);//kinda works for orange

	//YUV for red box in my room, different lighting conditions:
	//y=111 u=121 v=224
	//149 120 214
	//86 112 208
	//72 121 190
	//233 130 164
	Blackfin_Bin_Range(0, 65, 240, 100, 140, 160, 230);//for tracking red sparkfun box

	//Blackfin_Bin_Range(0, 10, 240, 90, 150, 80, 120);//should but doesn't work
	//Blackfin_Bin_Range(0, 15, 240, Y_mean, 180, 80, V_mean);

	//average in room is y=114, u=126, v=118
	//roof lights y=104, u=128, v=126
	//floor y=119, u=127, v=130
	//with ball y=103, u=130, v=113

	//find ball in camera and move to it, just like MOBOT algorithm
	//find blobs for bin#
	Blackfin_Blob_Detect(0);

	rprintf("\r\n moving robot to object");
	//rotate head to center on ball
	//pixel count, damping ratio
	Blackfin_HeadTrack(4, 25);//1,25

	//rotate body to center to head, pass forward speed value
	//ERP_body_track(100);//modify speed based on ball distance?
	}

//return ball back to owner
void return_ball(void)
	{
	while(1);//do nothing for now until rest of code is working
	}

void set_up_cam(void)
	{
	//configure camera, just once
	Blackfin_Initialize();
	//find mean color values of environment, do often?
	Blackfin_YUV_Mean();
	}

//this function tells the robot to play fetch
void play_fetch(void)
	{
	int ball_center_threshold=10;//defines a box that is the center

	while(1)
		{
		//find the ball, and move to it
		track_ball();
		delay_ms(25);//makes a huge difference with track_ball();

		//get distance reading
		sharp_IR=a2dConvert8bit(14);
		
		//move forward until ball is centered AND sharp IR gets a reading of ??
		//if ball is centered in screen
		//and Sharp IR gets close threshold reading
		if (X_centroid > (40-ball_center_threshold) && X_centroid < (40+ball_center_threshold)
			&& Y_centroid > (32-ball_center_threshold) && Y_centroid < (32+ball_center_threshold)
			&& sharp_IR > 35)
			{
			grab_ball();
			delay_ms(100);
			throw_ball();//cause im too lazy to do something with it, just throw it or something
			
			//if ball is no longer in view, victory!
			//check for ball
			//Blackfin_Blob_Detect(0);
			//if(pixels<5)//too few pixels, ball is probably gone
				//return_ball();//now return ball back to owner

			//else, if ball is still there, start over =(
			}
		}
	}
