/****************************************************************************
*
*   Copyright (c) 2008 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
****************************************************************************/

//This file stores walking gaits

//initialize variables
//these variables store only current servo location
long signed int arm_left_base;
long signed int arm_left_J1;
long signed int arm_left_J2;
long signed int arm_left_claw;
long signed int arm_right_base;
long signed int arm_right_J1;
long signed int arm_right_J2;
long signed int arm_right_claw;
long signed int wheel_left;
long signed int wheel_right;
long signed int camera_hor;
long signed int camera_ver;

//initialize home variables - FOLD POSITION
//tweak these numbers until biped stands up strait
long signed int home_arm_left_base=735;
long signed int home_arm_left_J1=1120;
long signed int home_arm_left_J2=1100;
long signed int home_arm_left_claw=900;
long signed int home_arm_right_base=620;
long signed int home_arm_right_J1=360;
long signed int home_arm_right_J2=350;
long signed int home_arm_right_claw=550;
long signed int home_wheel_left=715;
long signed int home_wheel_right=713;
long signed int home_camera_hor=730;
long signed int home_camera_ver=990;

//gaits to be stored in EEPROM
//EEPROM tutorial: http://www.societyofrobots.com/member_tutorials/node/309

//define walking forward gait
/*int forward_count=7;//number of positions in the gait array
long signed int forward_arm_left_base[20]=	{-100,-150,-200,-300,-300,-150,0};//increase to rotate clockwise from top
long signed int forward_arm_left_J1[20]=	{-100,-150,-200,-400,-300,-150,0};//decrease to go out of folding position
long signed int forward_arm_left_J2[20]=	{-100,-150,-200,-400,-300,-150,0};//decrease to do praying mantis position
long signed int forward_arm_left_claw[20]=	{-100,-150,-200,-400,-300,-150,0};//decrease to open
long signed int forward_arm_right_base[20]=	{-100,-150,-200,-300,-300,-150,0};//increase to rotate clockwise from top
long signed int forward_arm_right_J1[20]=	{100,150,200,400,300,150,0};//increase to go out of folding position
long signed int forward_arm_right_J2[20]=	{100,150,200,400,300,150,0};//increase to do praying mantis position
long signed int forward_arm_right_claw[20]=	{100,150,200,400,300,150,0};//increase to open
long signed int forward_wheel_left[20]=		{0,0,0,0,0,0,0};//increase for robot to turn left
long signed int forward_wheel_right[20]=	{0,0,0,0,0,0,0};//increase for robot to turn left
long signed int forward_camera_hor[20]=		{100,150,200,250,300,350,0};//increase to look right
long signed int forward_camera_ver[20]=		{50,-50,-150,-300,-325,-350,-400};//increase to look up
*/
//define walking forward gait
int forward_count=20;//number of positions in the gait array
long signed int forward_arm_left_base[20]=	{-100,-150,-200,-325,-300,-150,0,100,150,200,325,300,150,0,-150,-300,-150,-50,10,0};//increase to rotate clockwise from top
long signed int forward_arm_left_J1[20]=	{-100,-150,-200,-400,-600,-750,-750,-750,-750,-750,-750,-750,-750,-750,-750,-750,-300,-100,0};//decrease to go out of folding position
long signed int forward_arm_left_J2[20]=	{-100,-150,-300,-400,-700,-800,-700,-800,-700,-600,-600,-600,-600,-600,-400,-200,-100,-50,0,0};//decrease to do praying mantis position
long signed int forward_arm_left_claw[20]=	{-100,-150,-200,-400,-300,-350,-300,0,0,-100,-150,-200,-400,-300,-350,-300,0,0,0,0};//decrease to open
long signed int forward_arm_right_base[20]=	{-100,-150,-200,-280,-280,-150,0,100,150,200,325,300,150,0,-150,-300,-150,-50,10,0};//increase to rotate clockwise from top
long signed int forward_arm_right_J1[20]=	{100,150,200,400,600,750,750,750,750,750,750,750,750,750,750,750,300,100,0};//increase to go out of folding position
long signed int forward_arm_right_J2[20]=	{100,150,300,400,700,800,700,800,700,600,600,600,600,600,400,200,100,50,0,0};//increase to do praying mantis position
long signed int forward_arm_right_claw[20]=	{100,150,200,400,300,350,300,0,0,100,150,200,400,300,350,300,0,0,0,0};//increase to open
long signed int forward_wheel_left[20]=		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};//increase for robot to turn left
long signed int forward_wheel_right[20]=	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};//increase for robot to turn left
long signed int forward_camera_hor[20]=		{-100,-150,-200,-325,-300,-150,0,100,150,200,325,300,150,0,-150,-300,-150,-50,10,0};//increase to look right
long signed int forward_camera_ver[20]=		{0,-100,-250,-400,-400,-400,-400,-300,-200,-100,0,0,0,0,0,0,0,0,0,0};//increase to look up

//define dance lifting gait 
int lifting_count=2;//number of positions in the gait array
long signed int lifting_arm_left_base[2]=	{350,350};//increase to rotate clockwise from top
long signed int lifting_arm_left_J1[2]=		{0,-200};//decrease to go out of folding position
long signed int lifting_arm_left_J2[2]=		{300,50};//decrease to do praying mantis position
long signed int lifting_arm_left_claw[2]=	{-200,0};//decrease to open
long signed int lifting_arm_right_base[2]=	{-350,-350};//increase to rotate clockwise from top
long signed int lifting_arm_right_J1[2]=	{0,200};//increase to go out of folding position
long signed int lifting_arm_right_J2[2]=	{-300,-50};//increase to do praying mantis position
long signed int lifting_arm_right_claw[2]=	{200,0};//increase to open
long signed int lifting_camera_hor[2]=		{-50,50};//increase to look right
long signed int lifting_camera_ver[2]=		{-50,50};//increase to look up


//define dance bowing gait 
int bowing_count=2;//number of positions in the gait array
long signed int bowing_arm_left_base[2]=	{0,0};//increase to rotate clockwise from top
long signed int bowing_arm_left_J1[2]=		{-350,-750};//decrease to go out of folding position
long signed int bowing_arm_left_J2[2]=		{-690,-710};//decrease to do praying mantis position
long signed int bowing_arm_left_claw[2]=	{-300,0};//decrease to open
long signed int bowing_arm_right_base[2]=	{0,0};//increase to rotate clockwise from top
long signed int bowing_arm_right_J1[2]=		{350,750};//increase to go out of folding position
long signed int bowing_arm_right_J2[2]=		{690,710};//increase to do praying mantis position
long signed int bowing_arm_right_claw[2]=	{300,0};//increase to open
long signed int bowing_camera_hor[2]=		{0,0};//increase to look right
long signed int bowing_camera_ver[2]=		{10,-150};//increase to look up

//define dance bowing gait 
int cheering_count=2;//number of positions in the gait array
long signed int cheering_arm_left_base[2]=	{200,250};//increase to rotate clockwise from top
long signed int cheering_arm_left_J1[2]=	{0,-200};//decrease to go out of folding position
long signed int cheering_arm_left_J2[2]=	{0,-200};//decrease to do praying mantis position
long signed int cheering_arm_left_claw[2]=	{0,-300};//decrease to open
long signed int cheering_arm_right_base[2]=	{-200,-250};//increase to rotate clockwise from top
long signed int cheering_arm_right_J1[2]=	{0,200};//increase to go out of folding position
long signed int cheering_arm_right_J2[2]=	{0,200};//increase to do praying mantis position
long signed int cheering_arm_right_claw[2]=	{0,300};//increase to open
long signed int cheering_camera_hor[2]=		{0,-50};//increase to look right
long signed int cheering_camera_ver[2]=		{0,150};//increase to look up



//various common initialized variables
int i;
int j;

float per_a;
float per_b;
int next;

//this function calculates gait meshing
void calculate_per(int speed, int gait_count)
	{
	//mesh current gait position with future gait position
	per_a = ((float)(speed-j)) / ((float)speed);
	per_b = (float)1.0-per_a;

	//make sure future gait position isn't outside array
	if(i!=gait_count-1)
		next=i+1;
	else //if it is, then restart back at zero
		next=0;
	}

//command biped to do stuff
void biped_move(void)
	{
	arm_left_base(arm_left_base+home_arm_left_base);
	arm_left_J1(arm_left_J1+home_arm_left_J1);
	arm_left_J2(arm_left_J2+home_arm_left_J2);
	arm_left_claw(arm_left_claw+home_arm_left_claw);
	arm_right_base(arm_right_base+home_arm_right_base);
	arm_right_J1(arm_right_J1+home_arm_right_J1);
	arm_right_J2(arm_right_J2+home_arm_right_J2);
	arm_right_claw(arm_right_claw+home_arm_right_claw);
	//wheel_left(wheel_left+home_wheel_left);
	//wheel_right(wheel_right+home_wheel_right);
	camera_hor(camera_hor+home_camera_hor);
	camera_ver(camera_ver+home_camera_ver);
	}

//home position
//all positions are zeroed onto home position
void home_position(void)
	{
	arm_left_base=0;
	arm_left_J1=0;
	arm_left_J2=0;
	arm_left_claw=0;
	arm_right_base=0;
	arm_right_J1=0;
	arm_right_J2=0;
	arm_right_claw=0;
	wheel_left=0;
	wheel_right=0;
	camera_hor=0;
	camera_ver=0;

	biped_move();
	}

//walking forward gait
//higher speed makes robot walk slower
void walk_forward(int speed)
	{

	for (i=0;i<forward_count;i++)
		{
		//to test a particular position, uncomment i and j below
		//and set it to a particular value
		//i=3;
		rprintf("%d\r\n",i);
		//send each command several times
		for (j=0;j<speed;j++)
			{
			//j=0;//for testing particular kinematics points

			calculate_per(speed, forward_count);

			arm_left_base=forward_arm_left_base[i]*per_a + forward_arm_left_base[next]*per_b;
			arm_left_J1=forward_arm_left_J1[i]*per_a + forward_arm_left_J1[next]*per_b;
			arm_left_J2=forward_arm_left_J2[i]*per_a + forward_arm_left_J2[next]*per_b;
			arm_left_claw=forward_arm_left_claw[i]*per_a + forward_arm_left_claw[next]*per_b;
			arm_right_base=forward_arm_right_base[i]*per_a + forward_arm_right_base[next]*per_b;
			arm_right_J1=forward_arm_right_J1[i]*per_a + forward_arm_right_J1[next]*per_b;
			arm_right_J2=forward_arm_right_J2[i]*per_a + forward_arm_right_J2[next]*per_b;
			arm_right_claw=forward_arm_right_claw[i]*per_a + forward_arm_right_claw[next]*per_b;

			//wheel_left=forward_wheel_left[i]*per_a + forward_wheel_left[next]*per_b;
			//wheel_right=forward_wheel_right[i]*per_a + forward_wheel_right[next]*per_b;
			camera_hor=forward_camera_hor[i]*per_a + forward_camera_hor[next]*per_b;
			camera_ver=forward_camera_ver[i]*per_a + forward_camera_ver[next]*per_b;
			
			biped_move();
			}
		}
	}

//dancing gait, lifting
//higher speed makes robot walk slower
void dance_lift(int speed)
	{

	for (i=0;i<lifting_count;i++)
		{
		//to test a particular position, uncomment i and j below
		//and set it to a particular value
		//i=3;
		rprintf("%d\r\n",i);
		//send each command several times
		for (j=0;j<speed;j++)
			{
			//j=0;//for testing particular kinematics points

			calculate_per(speed, lifting_count);

			arm_left_base=lifting_arm_left_base[i]*per_a + lifting_arm_left_base[next]*per_b;
			arm_left_J1=lifting_arm_left_J1[i]*per_a + lifting_arm_left_J1[next]*per_b;
			arm_left_J2=lifting_arm_left_J2[i]*per_a + lifting_arm_left_J2[next]*per_b;
			arm_left_claw=lifting_arm_left_claw[i]*per_a + lifting_arm_left_claw[next]*per_b;
			arm_right_base=lifting_arm_right_base[i]*per_a + lifting_arm_right_base[next]*per_b;
			arm_right_J1=lifting_arm_right_J1[i]*per_a + lifting_arm_right_J1[next]*per_b;
			arm_right_J2=lifting_arm_right_J2[i]*per_a + lifting_arm_right_J2[next]*per_b;
			arm_right_claw=lifting_arm_right_claw[i]*per_a + lifting_arm_right_claw[next]*per_b;

			camera_hor=lifting_camera_hor[i]*per_a + lifting_camera_hor[next]*per_b;
			camera_ver=lifting_camera_ver[i]*per_a + lifting_camera_ver[next]*per_b;
			
			biped_move();
			}
		}
	}

//dancing gait, bowing
//higher speed makes robot walk slower
void dance_bowing(int speed)
	{

	for (i=0;i<bowing_count;i++)
		{
		//to test a particular position, uncomment i and j below
		//and set it to a particular value
		//i=3;
		rprintf("%d\r\n",i);
		//send each command several times
		for (j=0;j<speed;j++)
			{
			//j=0;//for testing particular kinematics points

			calculate_per(speed, bowing_count);

			arm_left_base=bowing_arm_left_base[i]*per_a + bowing_arm_left_base[next]*per_b;
			arm_left_J1=bowing_arm_left_J1[i]*per_a + bowing_arm_left_J1[next]*per_b;
			arm_left_J2=bowing_arm_left_J2[i]*per_a + bowing_arm_left_J2[next]*per_b;
			arm_left_claw=bowing_arm_left_claw[i]*per_a + bowing_arm_left_claw[next]*per_b;
			arm_right_base=bowing_arm_right_base[i]*per_a + bowing_arm_right_base[next]*per_b;
			arm_right_J1=bowing_arm_right_J1[i]*per_a + bowing_arm_right_J1[next]*per_b;
			arm_right_J2=bowing_arm_right_J2[i]*per_a + bowing_arm_right_J2[next]*per_b;
			arm_right_claw=bowing_arm_right_claw[i]*per_a + bowing_arm_right_claw[next]*per_b;

			camera_hor=bowing_camera_hor[i]*per_a + bowing_camera_hor[next]*per_b;
			camera_ver=bowing_camera_ver[i]*per_a + bowing_camera_ver[next]*per_b;
			
			biped_move();
			}
		}
	}

//dancing gait, bowing
//higher speed makes robot walk slower
void dance_cheering(int speed)
	{

	for (i=0;i<cheering_count;i++)
		{
		//to test a particular position, uncomment i and j below
		//and set it to a particular value
		//i=3;
		rprintf("%d\r\n",i);
		//send each command several times
		for (j=0;j<speed;j++)
			{
			//j=0;//for testing particular kinematics points

			calculate_per(speed, cheering_count);

			arm_left_base=cheering_arm_left_base[i]*per_a + cheering_arm_left_base[next]*per_b;
			arm_left_J1=cheering_arm_left_J1[i]*per_a + cheering_arm_left_J1[next]*per_b;
			arm_left_J2=cheering_arm_left_J2[i]*per_a + cheering_arm_left_J2[next]*per_b;
			arm_left_claw=cheering_arm_left_claw[i]*per_a + cheering_arm_left_claw[next]*per_b;
			arm_right_base=cheering_arm_right_base[i]*per_a + cheering_arm_right_base[next]*per_b;
			arm_right_J1=cheering_arm_right_J1[i]*per_a + cheering_arm_right_J1[next]*per_b;
			arm_right_J2=cheering_arm_right_J2[i]*per_a + cheering_arm_right_J2[next]*per_b;
			arm_right_claw=cheering_arm_right_claw[i]*per_a + cheering_arm_right_claw[next]*per_b;

			camera_hor=cheering_camera_hor[i]*per_a + cheering_camera_hor[next]*per_b;
			camera_ver=cheering_camera_ver[i]*per_a + cheering_camera_ver[next]*per_b;
			
			biped_move();
			}
		}
	}
